using UnityEngine;
using System.Collections;
namespace Mod
{
    
    public class LevelThreeDoorBehaviour : MonoBehaviour
    {
        public Sprite green = ModAPI.LoadSprite("doorgreen.png");
        public Sprite red = ModAPI.LoadSprite("doorred.png");
        public Sprite door = ModAPI.LoadSprite("door.png");
        IEnumerator OpenClose()
        {
            SpriteRenderer doorsprite = this.gameObject.GetComponent<SpriteRenderer>();
            foreach (var c in this.GetComponents<Collider2D>())
            {
                c.enabled = false;
            }
            ModAPI.Notify(this.gameObject.name + " just opened");
            doorsprite.sprite = green;
            yield return new WaitForSeconds(1);

            yield return new WaitForSeconds(2);
            doorsprite.sprite = door;
            ModAPI.Notify(this.gameObject.name + " just closed");   
            foreach (var c in this.GetComponents<Collider2D>())
            {
                c.enabled = true;
            }
        }





        IEnumerator ErrorDoor()
        {
            SpriteRenderer doorsprite = this.gameObject.GetComponent<SpriteRenderer>();
            ModAPI.Notify(this.gameObject.name + " cant be opened with that level keycard");
            doorsprite.sprite = red;
            yield return new WaitForSeconds(3);
            doorsprite.sprite = door;
        }







        void OnCollisionEnter2D(Collision2D collision)
        {
            if (collision.gameObject.name == "Level One Keycard") { 
                StartCoroutine(ErrorDoor());
            } else if (collision.gameObject.name == "Level Two Keycard") { 
                StartCoroutine(ErrorDoor());
            } else if (collision.gameObject.name == "Level Three Keycard") { 
                StartCoroutine(OpenClose());
            } else if (collision.gameObject.name == "Level Four Keycard") { 
                        StartCoroutine(OpenClose());
            } else if (collision.gameObject.name == "Level Five Keycard") { 
                StartCoroutine(OpenClose());
            } else if (collision.gameObject.name == "Omni Keycard") {
                StartCoroutine(OpenClose());
            }
        }
    }
}