using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;



namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
        CategoryBuilder.Create("SCPFoundation", "", ModAPI.LoadSprite("scplogo.png", 4));



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
        NameOverride = "(WIP) SCP-178",
        DescriptionOverride = "(WIP) A pair of 3D glasses",
        NameToOrderByOverride = "C",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("specsthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("specs.png");
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = .05f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .05f;
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = .05f;
            armor.stabResistance = 20f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = "specs.png";

            Instance.FixColliders();
            

        }  
    }
);














ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
        NameOverride = "Gas Mask",
        DescriptionOverride = "smoke: hi  ||  lungs: NO",
        NameToOrderByOverride = "C",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("gasmaskthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gasmask.png");
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = .05f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .05f;
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = .05f;
            armor.stabResistance = 20f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = "gasmask.png";

            Instance.FixColliders();
            

        }  
    }
);














ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
        NameOverride = "(WIP) Headphones",
        DescriptionOverride = "Should protect people from SCP-513",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        NameToOrderByOverride = "Z",
        ThumbnailOverride = ModAPI.LoadSprite("headphonesthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("headphones.png");
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = .06f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .06f;
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = .06f;
            armor.stabResistance = 20f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = "headphones.png";

            Instance.FixColliders();
            

        }  
    }
);



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Class-D",
        NameToOrderByOverride = "A",
        DescriptionOverride = "A prisoner that decided to work for the SCP Foundation instead of choosing death",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("classdthumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("classd.png");
            var flesh = ModAPI.LoadTexture("defaultflesh.png");
            var bone = ModAPI.LoadTexture("defaultflesh.png");
            //Instance.AddComponent<DClassBlinkBehaviour>();
            var person = Instance.GetComponent<PersonBehaviour>();
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Class-E",
        NameToOrderByOverride = "A",
        DescriptionOverride = "idk what is is",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("classethumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("classe.png");
            var flesh = ModAPI.LoadTexture("defaultflesh.png");
            var bone = ModAPI.LoadTexture("defaultflesh.png");
            var person = Instance.GetComponent<PersonBehaviour>();
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "SCP Foundation Guard",
        DescriptionOverride = "A Guard who works for the SCP Foundation",
        NameToOrderByOverride = "A",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("guardthumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("guard.png");
            var flesh = ModAPI.LoadTexture("defaultflesh.png");
            var bone = ModAPI.LoadTexture("defaultflesh.png");
            var person = Instance.GetComponent<PersonBehaviour>();
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "SCP Foundation Scientist",
        DescriptionOverride = "A scientist who works for the SCP Foundation that tests on SCPs",
        NameToOrderByOverride = "A",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("scientistthumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("scientist.png");
            var flesh = ModAPI.LoadTexture("defaultflesh.png");
            var bone = ModAPI.LoadTexture("defaultflesh.png");
            var person = Instance.GetComponent<PersonBehaviour>();
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "(WIP TEXTURE) SCP Foundation Nine Tailed Fox",
        DescriptionOverride = "(WIP TEXTURE) A higher level security guard that works for the SCP Foundation with a higher level keycard than most personnel",
        NameToOrderByOverride = "A",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("ntfthumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("ntf.png");
            var flesh = ModAPI.LoadTexture("defaultflesh.png");
            var bone = ModAPI.LoadTexture("defaultflesh.png");
            var person = Instance.GetComponent<PersonBehaviour>();
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
        }
    }
);


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Mobile Task Force",
        DescriptionOverride = "They use these people in groups when a containment breach happens",
        NameToOrderByOverride = "A",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("mtfthumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("mtf.png");
            var flesh = ModAPI.LoadTexture("defaultflesh.png");
            var bone = ModAPI.LoadTexture("defaultflesh.png");
            var person = Instance.GetComponent<PersonBehaviour>();
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Chaos Insurgency",
        DescriptionOverride = "green mtf who protec d clas",
        NameToOrderByOverride = "A",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("chaosthumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("chaos.png");
            var flesh = ModAPI.LoadTexture("defaultflesh.png");
            var bone = ModAPI.LoadTexture("defaultflesh.png");
            var person = Instance.GetComponent<PersonBehaviour>();
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);



            var head = Instance.transform.GetChild(5);
            var cObj = new GameObject("chaosgasmask");
            cObj.transform.SetParent(head);
            cObj.transform.localPosition = new Vector3(0.14f, -0.09f);
            cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            cObj.transform.localScale = new Vector3(1f, 1f);
            var cSpr = cObj.AddComponent<SpriteRenderer>();
            cSpr.sprite = ModAPI.LoadSprite("chaosmask.png");
            cSpr.sortingLayerName = "Top"; 
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "SCP-049",
        DescriptionOverride = "plage docor lmfao",
        NameToOrderByOverride = "A",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("049thumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("049.png");
            var flesh = ModAPI.LoadTexture("defaultflesh.png");
            var bone = ModAPI.LoadTexture("defaultflesh.png");
            var person = Instance.GetComponent<PersonBehaviour>();
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
            foreach (LimbBehaviour limb in person.Limbs) {
                if (limb.name == "LowerArm" || limb.name == "LowerArmFront") { 
                    limb.gameObject.AddComponent<SCP049Behaviour>();
                };
            };
            //var larm = person.transform.Find("LowerArm");
            //larm.gameObject.AddComponent<SCP049Behaviour>();
            //var rarm = person.transform.Find("LowerArmFront");
            //rarm.gameObject.AddComponent<SCP049Behaviour>();
//

            var head = Instance.transform.GetChild(5);
            var cObj = new GameObject("049masklmao");
            cObj.transform.SetParent(head);
            cObj.transform.localPosition = new Vector3(0.2f, 0f);
            cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            cObj.transform.localScale = new Vector3(1f, 1f);
            var cSpr = cObj.AddComponent<SpriteRenderer>();
            cSpr.sprite = ModAPI.LoadSprite("049mask.png");
            cSpr.sortingLayerName = "Top"; 
        }
    }
);



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "SCP-096",
        DescriptionOverride = "scary face man lmfao",
        NameToOrderByOverride = "A",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("096thumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("096.png");
            var flesh = ModAPI.LoadTexture("defaultflesh.png");
            var bone = ModAPI.LoadTexture("defaultflesh.png");
            var person = Instance.GetComponent<PersonBehaviour>();
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
            //var head = Instance.transform.GetChild(7);
            //head.gameObject.transform.localScale = new Vector3(0f, 0.5f, 0f);
            foreach (var body in person.Limbs)
            {
                //body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");;
                body.Health *= 7f;
            }
            //foreach (LimbBehaviour limb in person.Limbs) {
            //    if (limb.name == "LowerArm" || limb.name == "LowerArmFront") {
            //        limb.gameObject.transform.localScale = new Vector3(0f, 0.5f, 0f);
            //    //} else if (limb.name == "Head") { 
            //    //    limb.gameObject.AddComponent<SCP096Behaviour>();
            //    };
            //};
            ////var larm = person.transform.Find("LowerArm");
            ////larm.gameObject.AddComponent<SCP049Behaviour>();
            ////var rarm = person.transform.Find("LowerArmFront");
            ////rarm.gameObject.AddComponent<SCP049Behaviour>();
////
//
            //var head = Instance.transform.GetChild(6);
            //var cObj = new GameObject("049masklmao");
            //cObj.transform.SetParent(head);
            //cObj.transform.localPosition = new Vector3(0.2f, 0f);
            //cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            //cObj.transform.localScale = new Vector3(1f, 1f);
            //var cSpr = cObj.AddComponent<SpriteRenderer>();
            //cSpr.sprite = ModAPI.LoadSprite("049mask.png");
            //cSpr.sortingLayerName = "Top"; 
        }
    }
);




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//KEYCARDS
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Level One Keycard",
        DescriptionOverride = "A Keycard that can open some doors",
        NameToOrderByOverride = "B",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("level1thumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("level1.png");
            Instance.FixColliders();
            Instance.transform.localScale = new Vector3(0.3f, 0.3f);
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Level Two Keycard",
        DescriptionOverride = "A Keycard that can open more than some doors",
        NameToOrderByOverride = "B",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("level2thumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("level2.png");
            Instance.FixColliders();
            Instance.transform.localScale = new Vector3(0.3f, 0.3f);
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Level Three Keycard",
        DescriptionOverride = "A Keycard that can open more than the doors that the level two keycard can open",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        NameToOrderByOverride = "B",
        ThumbnailOverride = ModAPI.LoadSprite("level3thumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("level3.png");
            Instance.FixColliders();
            Instance.transform.localScale = new Vector3(0.3f, 0.3f);
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Level Four Keycard",
        DescriptionOverride = "A Keycard that can open more than the doors that the level three and the level two keycard can open",
        NameToOrderByOverride = "B",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("level4thumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("level4.png");
            Instance.FixColliders();
            Instance.transform.localScale = new Vector3(0.3f, 0.3f);
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Level Five Keycard",
        NameToOrderByOverride = "B",
        DescriptionOverride = "HOW THE F### DID YOU GET THIS",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("level5thumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("level5.png");
            Instance.FixColliders();
            Instance.transform.localScale = new Vector3(0.3f, 0.3f);
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Omni Keycard",
        NameToOrderByOverride = "B",
        DescriptionOverride = "major luck bro",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("omnithumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("omni.png");
            Instance.FixColliders();
            Instance.transform.localScale = new Vector3(0.3f, 0.3f);
        }  
    }
);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//DOORS   VVVV
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Anchor"),
        NameOverride = "Level 1 Door",
        DescriptionOverride = "A door that can be opened with a level 1 keycard or higher",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("doorthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("door.png");
            Instance.FixColliders();
            Instance.AddComponent<LevelOneDoorBehaviour>();

            //AudioSource Close = Instance.AddComponent<AudioSource>();
            //Close.clip = ModAPI.LoadSound("DoorClose.wav");

            //AudioSource Open = Instance.AddComponent<AudioSource>();
            //Open.clip = ModAPI.LoadSound("DoorOpen.wav");

            //Instance.GetComponent<LevelOneDoorBehaviour>().Open = Open;
            //Instance.GetComponent<LevelOneDoorBehaviour>().Close = Close;
            //Instance.GetComponent<LevelOneDoorBehaviour>().Close.clip = ModAPI.LoadSound("DoorClose.ogg");
            //Instance.GetComponent<LevelOneDoorBehaviour>().Open.clip = ModAPI.LoadSound("DoorOpen.ogg");

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Anchor"),
        NameOverride = "Level 2 Door",
        DescriptionOverride = "A door that can be opened with a level 2 keycard or higher",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("doorthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            //LevelOneDoorBehaviour
            Instance.AddComponent<LevelTwoDoorBehaviour>();
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("door.png");
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Anchor"),
        NameOverride = "Level 3 Door",
        DescriptionOverride = "A door that can be opened with a level 3 keycard or higher",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("doorthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            //LevelOneDoorBehaviour
            Instance.AddComponent<LevelThreeDoorBehaviour>();
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("door.png");
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Anchor"),
        NameOverride = "Level 4 Door",
        DescriptionOverride = "A door that can be opened with a level 4 keycard or higher",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("doorthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            //LevelOneDoorBehaviour
            Instance.AddComponent<LevelFourDoorBehaviour>();
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("door.png");
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Anchor"),
        NameOverride = "Level 5 Door",
        DescriptionOverride = "A door that can be opened with a level 5 keycard or higher",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("doorthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            //LevelOneDoorBehaviour
            Instance.AddComponent<LevelFiveDoorBehaviour>();
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("door.png");
            Instance.FixColliders();
        }
    }
);





//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//SCPS   VVVV
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "(WIP) SCP-513",
        NameToOrderByOverride = "C",
        DescriptionOverride = "(WIP) You’ve seen it. Now he can hear you. You’ve touched it. Now he can see you. Never ring it. If you hear it, he can touch you",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("bellthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("bell.png");
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = .02f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .02f;
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = .02f;
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "(BUGGY, BUT WORKING) SCP-714",
        NameToOrderByOverride = "C",
        DescriptionOverride = "(BUGGY, BUT WORKING) A jade ring",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("ringthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ring.png");
            Instance.FixColliders();
            Instance.AddComponent<SCP714Behaviour>();
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = .01f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .01f;
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = .01f;
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "SCP-207",
        NameToOrderByOverride = "C",
        DescriptionOverride = "A bottle of the brand 'Coca Cola' that gives you adrenaline",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("colathumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("cola.png");
            Instance.FixColliders();
            Instance.AddComponent<SCP207Behaviour>();
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = .03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .03f;
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = .03f;
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "SCP-500",
        NameToOrderByOverride = "C",
        DescriptionOverride = "A red pill that can cure everything",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("pillthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pill.png");
            Instance.FixColliders();
            Instance.AddComponent<SCP500Behaviour>();
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = .01f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .01f;
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = .01f;
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
        NameOverride = "(WIP) SCP-1507",
        NameToOrderByOverride = "C",
        DescriptionOverride = "(WIP) A plastic lawn flamingo",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("flamingothumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("flamingo.png");
            Instance.FixColliders();
        }  
    }
);

////////////////////////////go all the way up for scp 178

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
        NameOverride = "(WIP) SCP-1025",
        NameToOrderByOverride = "C",
        DescriptionOverride = "(WIP) A book of common diseases",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("bookthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("book.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
        NameOverride = "(WIP) SCP-018",
        NameToOrderByOverride = "C",
        DescriptionOverride = "ball",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("ballthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ball.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "(WIP) SCP-173",
        NameToOrderByOverride = "C",
        DescriptionOverride = "statue lmfao",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("nutthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("nut.png");
            Instance.FixColliders();
            Instance.AddComponent<SCP173Behaviour>();
            Instance.transform.localScale = new Vector3(0.37f, 0.37f);
        }  
    }
);


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "(WIP) SCP-294",
        NameToOrderByOverride = "C",
        DescriptionOverride = "coffee machine lmfao",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("294thumb.png"),
        AfterSpawn = (Instance) =>
        { 
            ModAPI.Notify("SCP-207 is the only object that this dispenses and i will add more objects in the future"); 
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("294.png");
            Instance.FixColliders();
            Instance.AddComponent<SCP294Behaviour>();
            Instance.gameObject.AddComponent<UseEventTrigger>().Action = () =>
            {
                ModAPI.Notify("SCP-207 is the only object that this dispenses"); 
                var scp207instance = ModAPI.CreatePhysicalObject("scp207", ModAPI.LoadSprite("cola.png"));
                scp207instance.transform.localPosition = new Vector3(1, 0);
            };
        }  
    }
);




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//MISC   VVVV
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Empty Clipboard",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("emptyclipboardthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("emptyclipboard.png");
            Instance.FixColliders();
        }  
    }
);


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Clipboard with Paper",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("clipboardthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("clipboard.png");
            Instance.FixColliders();
        }  
    }
);



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Grenade",
        DescriptionOverride = "boom",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("grenadethumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("grenade.png");
            Instance.FixColliders();
            Instance.AddComponent<ModGrenadeBehaviour>();
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = .03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .03f;
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = .03f;
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Ballistic Helmet",
        DescriptionOverride = "like a vest, but for your head",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
        ThumbnailOverride = ModAPI.LoadSprite("helmetthumb.png"),
        AfterSpawn = (Instance) =>
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("helmet.png");
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = .07f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .07f;
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = .07f;
            armor.stabResistance = 300f;
            armor.armorPiece = "Head";
            armor.armorTier = 3;
            armor.otherSprite = "helmet.png";
            Instance.FixColliders();
        }  
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("G1 Submachine Gun"),
        NameOverride = "P90",
        DescriptionOverride = "gun, but fast",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"), 
        ThumbnailOverride = ModAPI.LoadSprite("p90thumb.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("p90.png");
            var firearm = Instance.GetComponent<FirearmBehaviour>();
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
            customCartridge.name = "P90-Moment";
            customCartridge.Damage *= 0.3f;
            customCartridge.StartSpeed *= 2.3f; 
            customCartridge.PenetrationRandomAngleMultiplier *= 1.2f;
            customCartridge.Recoil *= 1.4f;
            customCartridge.ImpactForce *= 0.2f;
            firearm.Cartridge = customCartridge;
            Instance.FixColliders();
        }
    }
);



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
        NameOverride = "MTF-E11-SR",
        DescriptionOverride = "gun, but not that fast but powerful",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"), 
        ThumbnailOverride = ModAPI.LoadSprite("m11thumb.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("m11.png");
            var firearm = Instance.GetComponent<FirearmBehaviour>();
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
            customCartridge.name = "M11-Moment";
            customCartridge.Damage *= 0.9f;
            customCartridge.StartSpeed *= 1.9f; 
            customCartridge.PenetrationRandomAngleMultiplier *= 0.8f;
            customCartridge.Recoil *= 2.1f;
            customCartridge.ImpactForce *= 1.9f;
            firearm.Cartridge = customCartridge;
            Instance.transform.localScale = new Vector3(0.8f, 0.8f);
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Pistol"),
        NameOverride = "COM-15",
        DescriptionOverride = "gun, but not auto but very powerful",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"), 
        ThumbnailOverride = ModAPI.LoadSprite("comthumb.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("com.png");
            var firearm = Instance.GetComponent<FirearmBehaviour>();
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
            customCartridge.name = "COM-Moment";
            customCartridge.Damage *= 2.5f;
            customCartridge.StartSpeed *= 3f; 
            customCartridge.PenetrationRandomAngleMultiplier *= 2.4f;
            customCartridge.Recoil *= 2.6f;
            customCartridge.ImpactForce *= 2.3f;
            firearm.Cartridge = customCartridge;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Pistol"),
        NameOverride = "USP",
        DescriptionOverride = "gun, but not auto and not that powerful",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"), 
        ThumbnailOverride = ModAPI.LoadSprite("uspthumb.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("usp.png");
            var firearm = Instance.GetComponent<FirearmBehaviour>();
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
            customCartridge.name = "com-Moment";
            customCartridge.Damage *= 1.8f;
            customCartridge.StartSpeed *= 2.5f; 
            customCartridge.PenetrationRandomAngleMultiplier *= 1.4f;
            customCartridge.Recoil *= 1.7f;
            customCartridge.ImpactForce *= 1.2f;
            firearm.Cartridge = customCartridge;
            Instance.FixColliders();
        }
    }
);




ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Light Machine Gun"),
        NameOverride = "Logicer",
        DescriptionOverride = "gun, but full auto and incredibly powerful",
        CategoryOverride = ModAPI.FindCategory("SCPFoundation"), 
        ThumbnailOverride = ModAPI.LoadSprite("logicerthumb.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("logicer.png");
            var firearm = Instance.GetComponent<FirearmBehaviour>();
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
            customCartridge.name = "logicer-Moment";
            customCartridge.Damage *= 3.4f;
            customCartridge.StartSpeed *= 3.3f; 
            customCartridge.PenetrationRandomAngleMultiplier *= 5.2f;
            customCartridge.Recoil *= 3.7f;
            customCartridge.ImpactForce *= 3.678346598273465897f;
            firearm.Cartridge = customCartridge;
            Instance.transform.localScale = new Vector3(0.8f, 0.8f);
            Instance.FixColliders();
            
        }
    }
);




            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Ballistic Body Armor",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("SCPFoundation"),
                    ThumbnailOverride = ModAPI.LoadSprite("middlearmorthumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("middlearmor.png");
                        int PartCount = 3;
                        Instance.AddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();     
                        armor.stabResistance = 300f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 3;
                        armor.otherSprite = "middlearmor.png";
                        Instance.FixColliders();
                    }
                }
            );

        }
    }
}



